########################################################################################
# Jyton script which prints 'DCC-EX 4.1.0 Commands Summary by List & Group            #
#   a derivative of DCC++ author Gregg Berman 2015                                     #
#   & of DCC++EX Extended authors Chris Harlow, Harald Barth & Neil McKechnie 2021-22  #
#   Created and customized by Kevin Smith 2021-2023                                    #
#                                                                                      #
####################################################################################@@##

import jmri
#import jarray
import java
#import javax
#import javax.swing

class Commands(jmri.jmrit.automat.AbstractAutomaton):


    def init(self):
        print "****************** DCC-EX 4.1 Commands List Summary ************************ 8-30-2022 ******"
        print "**********************************************************************************************"
        print " "
        print " 'Single Commands'"
        print "  <1> Number One: Turn Power ON to (Both Main & Programming tracks)."
        print "  <0> Number Zero: Turn Power OFF to {Both Main & Programming tracks}."
        print "  <c> Lower case c: Displays the instantaneous current on the MAIN Track."
        print "  <E> Upper case E : Command to Store definitions to EEPROM."
        print "  <e> Lower Case e: Command to Erase ALL (turnouts, sensors, outputs) definitions from EEPROM."
        print "   ***(NOTE: There is NO Un-Delete)***"
        print "  <Q> Upper Case Q : Lists Status of all sensors."
        print "  <R> Upper Case R : Read Loco address (programming track only)"
        print "  <S> Upper Case S : Lists all defined sensors."
        print "  <s> Lower case s : DCC++EX Command Station Status & Build Version."
        print "  <T> Upper Case T : Lists all defined turnouts."
        print " <+X> Plus sign Upper case X: Special case to force CS into 'WiFi Connected' mode."
        print "  <Z> Upper Case Z : Lists all defined output pins."
        print "  <#> Show number of supported cabs on the Command Station"
        print "  <!> Exclamation Point !  EMERGENCY STOP - Stops all locos on the track, leaves power on."
        print " "
        print " 'Track Power Commands'"
        print "  <1 MAIN> Power On just to the MAIN track."
        print "  <0 MAIN> Power Off just to the MAIN track."
        print "  <1 PROG> Power ON just to the PROG track."
        print "  <0 PROG> Power OFF just to the PROG track."
        print "  <1 JOIN> Joins Programming track together with MAIN (ops) track. 1 PROG resets it to Normal"
        print " "
        print " 'DIAGNOSTICS'"
        print " 'D'Commands 1 and 0 and ON and OFF can be used interchangeably in DCC++ EX."
        print "  <D ACK 1> or <D ACK ON> Turn Diagnostic reply On."
        print "  <D ACK 0> or <D ACK OFF> Turn Diagnostic reply Off."
        print "  <D CABS> Shows cab numbers and speed in reminder table."
        print "  <D RAM> Shows remaining RAM."
        print "  <D CMD 1|0> or <D CMD ON|OFF> Enables Command Parser diagnostics."
        print "  <D WIFI 1|0> or <D WIFI ON|OFF> Enables WiFi diagnostics."
        print "  <D WIT 0|1> or <D WIT ON|OFF> Enables WiThrottle diagnostics."
        print "  <D ETHERNET ON|OFF> Enables Ethernet diagnostics"
        print "  <D LCN ON|OFF> Enables LCN interface diagnostics"
        print "  <D TEST|NORMAL> DCC Signal Diagnostics Replaces Old <D> only command (See Diagnosing Issues** for more help."
        print "  <D SPEED28|SPEED128> Switch between 28 and 128 speed steps."
        print "  <D ACK MIN xxxx> Set AckPulseDuration uS Minimum to xxxx <= 4000us. Use to Increase Or Decrease uS MIN."
        print "  <D ACK MAX xxxx> Set AckPulseDuration uS Maximum to xxxx >= 8500us. Use to Increase Or Decrease uS MAX."
        print "  <D ACK LIMIT xx> Set AckLimit mA to xx where xx is less than < or > greater than 60. Use to Increase or Decrease mA LIMIT."
        print "  <D PROGBOOST> The 250mA limit is removed with programming track switched on <1> or <1 PROG>."
        print "      **Caution Is Advised** Current flow can increase to Prog track."
        print "  <D RESET> Command to reboot Arduino and display a verbose boot log in Traffic DCC++ Monitor."
        print " "
        print " 'New I/O (HAL) Diagnostics'"
        print "  <D HAL SHOW> List HAL devices and allocated VPINs"
        print "  <D SERVO vpin value [profile]> Set servo position to value on pin vpin"
        print "  <D ANOUT pin value> Write the specified value and param2 to the analogue output VPIN pin. This is an alias for the <D SERVO…> command."
        print "                      The significance of param2 depends on the device type associated with the VPIN."
        print "  <D ANIN pin> Read the analogue value of the specified pin and display it. "
        print "               The value will be zero if the pin is not configured or does not support analogue read operations."
        print " "
        print " 'New Verify V CV byte or CV bit {use instead of a R command'"
        print " Verify tests the Guess value provided against the existing value, whether it matches or not."
        print "  <V CV BYTEVALUE> the value returned will be the existing Byte value from the decoder."
        print "  <V CV BIT BITVALUE> the value returned will be the existing Bit value from the decoder."
        print " "
        print " 'New Engine Decoder (CAB) Operation Commands' (CAB, Loco, Eng #) synonymous. "
        print "  {Note; Use of Reg # is now Optional, DCC++EX  Automatically Handles Registers. "
        print "         and Speed is in Percentage from 1% to 100% of 28 or 128 Speed steps}."
        print "  <t REGISTER CAB SPEED DIRECTION> CAB throttle format"
        print "     <t 1 03 20 1> Throttle Register 1, CAB 03, Speed 20%, Forward" 
        print "     <t 1225 35 0> Throttle, CAB 1225, Speed 35%, Reverse {no Register required}"
        print " "
        print " 'Forget CAB Format'"
        print "  <- [CAB]> (A minus as in 'subtract') Forgets one or all Locos."
        print "    <- 708>  Forgets loco at address 708."
        print "      <->  - Forgets all locos, Only a Minus in brackets."
        print " "
        print " 'DCC++EX 'F' Function Format {Capital F}'"
        print "  <F CAB FUNC 1|0> CAB Function Format turns engine decoder F0-F68 function-keys ON and OFF"
        print "  <F 3 0 1>        CAB 3 Turns the Headlight ON."
        print "  <F 708 0 0>      CAB 708 Turns the Headlight OFF."
        print "  <F 1225 1 1>     CAB 1225 Turns the Bell ON."
        print " "
        print " 'Legacy CAB Combined Function Format with Throttle Format' {'Deprecated'}"
        print "  <f CAB BYTE1 [BYTE2]> Function Format."
        print "  <t CAB SPEED DIRECTION> Throttle Format."
        print "  <f 1225 144>   CAB 1225 Turn on Headlight."
        print "  <t1 1225 30 1> CAB 1225, 30 speed (0-126 possible)the last '1' for Forward, '0' for Reverse."
        print "  <t1 1225 15 1> speed 15 slow forward."
        print "  <f 1225 146 >  head light + whistle."
        print "  <f 1225 144 >  head light only turn whistle off."
        print "  <t 1 1225 70 1>speed 70 medium forward."
        print "  <t1 1225 5 1>  speed 5% slow forward."
        print "  <f 1225 148 >  lights + short whistle."
        print "  <f 1225 145 >  Tinder light + bell for reverse."
        print "  <t1 1225 55 0> speed 55 the last '0' for reverse."
        print "  <t1 1225 5 0>  speed 5% slow in reverse."
        print " "
        print " 'Engine Decoder Programming Commands'"
        print " "
        print " 'PROGRAMMING-MAIN TRACK'"
        print " WRITE CV BYTE TO ENGINE DECODER ON MAIN TRACK."
        print "  Writes, without any verification, a Configuration Variable BYTE to an engine on the main ops track."
        print "   The short (1-127) or long (128-10293) address of the engine decoder"
        print "   The number of the Configuration Variable memory location in the decoder to write to (1-1024)"
        print "   The value to be written to the Configuration Variable memory location (0-255)"
        print "  <w CAB CV VALUE> Writes to CV# a new Value"
        print "  <w 3 52 1> Write CAB 3 BELL type 1"
        print "  <w 1225 51 55 > Write CAB 1225 WHISTLE Volume 55"
        print " "
        print " 'PROGRAMMING-PROGRAMMING TRACK'"
        print " WRITE CV BYTE TO ENGINE DECODER ON PROGRAMMING TRACK"
        print "  Writes, and then verifies, a Configuration Variable BYTE to an engine on the prog track."
        print "  The Addesses and CV and Variable values are the same as programming on the Main track above."
        print "  <W CV VALUE CALLBACKNUM CALLBACKSUB> Write CV Format."
        print "  <W 3 53 35 1 1> Write CAB 3 BELL Volume 35, any CBN any CBS."
        print "  <W 1225 50 5 1 1 > Write CAB 1225 WHISTLE type 5, any CBN any CBS."
        print "  Write & Change Cab Address"
        print "  <W 3>    Write short address 3 to CAB, valid short(1-127)addresses."
        print "  <W 1225> Write long address 1225 to CAB, valid long(128-10293)addresses."
        print " "
        print " 'New EX-RAIL Commands' Used Thru the JMRI Send DCC++ Command pane"
        print "  <D EXRAIL ON|OFF>    Turns on/off diagnostic traces for EX-RAIL events"
        print "  </PAUSE>             Pauses all automation - all locos ESTOP"
        print "  </RESUME>            Resumes automation - all locos are restarted at speed when paused"
        print "  </START[loco_addr]route_id> Starts a new task to send loco onto Route, or activate a non-loco Animation or Sequence"
        print "  </>                  Displays EX-RAIL running thread information"
        print "  </KILL task_id>      Kill a currently running script task by id (use </> to list task ID's"
        print "  </KILL ALL>          Kill All currently running script tasks"
        print "  </RESERVE block_id>  Manually reserves a virtual track Block"
        print "  </FREE block_id>     Manually frees a virtual track Block"
        print "  </LATCH sensor_id>   Lock sensor ON, preventing external state "
        print "  </UNLATCH sensor_id> Unlock sensor, returning to current external state "
        print "  </RED signal_id>     Set the specified signal red "
        print "  </AMBER signal_id>   Set the specified signal amber "
        print "  </GREEN signal_id>   Set the specified signal green "
        print "  </ROUTES>            ** Under Development** Returns the Routes & Automations control list in WiThrottle format. JMRI integration only!"
        print " "
        print " 'Accessory commands'"
        print "  <a ADDRESS SUBADDRESS ACTIVATE> Controlling an Accessory Decoder."
        print "  <a linear_address 1|0> an Accessory Decoder linear 1-2044 address On or OFF"
        print "  <a addr subaddr 1|0> an Accessory Decoder address 0-511 & sub 0-3 address On or OFF"
        print " "
        print " 'Turnouts' Three Types; DCC Accessory, A Vpin Turnout, or a Servo Turnout"
        print "  <T id address subaddress>     Define DCC turnout {depricated}"
        print "  <T id DCC address subaddress> Define DCC turnout "
        print "  <T id DCC Linear address>     Define DCC turnout "
        print "  <T id Vpin vpin>              Define Vpin turnout"
        print "  "
        print " 'New Servo-based Turnout'"
        print "  Create a new turnout ID on a PCA9685 Servo Board with a Angle position range from 102 to 490, provides 180 degrees motion,"
        print "   and a PROFILE, as 0 (immediate), 1(fast=0.5 sec), 2(medium=1 sec), 3(slow=2 sec) or 4(bounce, for semaphore signals)"
        print "  Use Vpin 100-115 for servos attached to the first PCA9685 Servo Controller module, 116-131 for the second PCA9685 module,"
        print "   and Vpin 164-179 for pins on the first MCP23017 GPIO Extender module, and 180-195 for the second MCP23017 module."
        print "  <T ID SERVO vpin throwPosition closedPosition Profile>"
        print "  <T 1 SERVO 101 410 305 2>   Turnout 1, vpin 101, Thrown 410 degree, Close 305 degree, speed 2 medium"
        print " 'Using Turnouts'"
        print "  <T>     List defined turnouts"
        print "  <T id>  Delete a turnout Id"
        print "  <T id 0|1>  Throw (1 or T) or Close(0 or C) a defined turnout"
        print " "
        print " 'Sensors'"
        print "  <Q>  Lists Status of all sensors"
        print "  <S>  Lists definition all defined sensors."
        print "  <S id pin 0|1> Creates a new sensor ID, with specified PIN and PULLUP"
        print "  <S id>  Deletes definition of sensor ID"
        print " "
        print " 'Outputs'"
        print "  <Z>   Lists all defined output pins"
        print "  <Z id pin iflag> Creates a new output ID, with specified PIN and IFLAG values"
        print "  <Z id 0|1> Sets output ID to either INACTIVE or ACTIVE state"
        print "  <Z id>  Deletes definition of output ID"
        print " "
        print " 'New Throttle Builder Transport Commands'"
        print "  <JA> Command Station EXRAIL (n) Sequence List"
        print "  <JR> Command Station Roster List"
        print "  <JT> Command Station Turnout List"
        print ""
        print " 'New WiFi Check AT Commands & Status' Works ONLY with Arduino IDE monitor, NOT JMRI Traffic monitor"
        print "  <+COMMAND> Plus sign followed by a command. Sends AT commands to the WiFi board (ESP8266, ESP32, etc.)."                  
        print "             There is not space between the '+' and the command."
        print "  <+X>   A special command to force the 'connected' flag to on inside the CS so that our loop will start"
        print "         seeing network traffic. If your code creates a connection outside of our normal WiFi code, this "
        print "         provides a way for you to notify the CS that it needs to process commands on a connection you created."
        print "  <+GMR>    Sends the 'AT+GMR' prints version information from the WiFi device. "
        print "  <+CIFSR>  Check WiFi in STA or AP mode and returns IP & MAC ID settings in the CS."
        print "  <+CIPSTA?> Check WiFi in STA or AP mode and returns IP, Gateway & Sub Netmask settings in the CS."
        print "  <+CISEND> Check Wifi response"
        print "  <+CWJAP?> Check WiFi in STA or AP mode and returns SSID Name & MAC ID settings in the CS."
        print "  <+CWLAP>  Check WiFi in STA or AP mode and returns available AP & STA Router Device."
        print "  <+CWHOSTNAME?> Check WiFi in Command Station and returns Host Name settings in the CS."
        print " "
        print " Users familiar with the AT Command Set of WiFi board may enter commands directly into the serial monitor in real-time"
        print " or as setup commands in the mySetup.h file. This allows users to override the default WiFi connect sequence or to "
        print " send any command to change a WiFi device setting."
        print " "
        print " 'User Defined'"
        print "  <U ...> Is reserved for user commands (through user filter)"
        print " "
        print "End of DCC-EX Commands List Summary"
        print " DCC-EX Commands 4.1.0.py script by KCSmith 8-2022"
        print "**********************************************************************************************"
        print " "
        print " "
        print "******************* DCC-EX 4.1 Commands Group Summary *********************** 8-30-2022 *****"
        print "**********************************************************************************************"
        print " "
        print " 'Power Management'"
        print "  <0 MAIN | PROG> Power Off to MAIN or PROG track"
        print "  <1 MAIN | PROG | JOIN> Power On to MAIN or PROG or JOIN(both)"
        print "  <c> Current On the Main Track"
        print "  <s> small 's' DCC++EX Command Station Status & Build Version."
        print "  <D RESET> Reboot the Command Station"
        print " "
        print " 'CAB Functions'"
        print "  <!> EMERGENCY STOP All Loco's leave track power On."
        print "  <t [ignored] cab speed 1|0> Throttle speed = or less than 126, direction 1=forward"
        print "  <- [cab]>  Remove one or all cabs from reminders."
        print "  <F cab func 1|0> turns engine decoder F0-F68 function-keys ON and OFF"
        print "  <f cab byte1 [byte2]> legacy functions, see Commands List Summary above"
        print "  <#> Show number of supported cabs"
        print "  <D SPEED28|SPEED128> Switch between 28 and 128 speed steps"
        print "  <M ignored hex1 hex2 [hex3 [hex4 [hex5]]]> Write a DCC packet the MAIN track"
        print "  <w cab cv value> Write CV on main track"
        print "  <b cab cv bit value> Write CV bit on main track"
        print " "
        print " 'Programming Track'"
        print "  <R> Read Loco address (on programming track only)"
        print "  <W cab> write cab address to loco on prog track. short(1-127) & long(128-10293)"
        print "  <W cv value > Write to CV# a value on prog track"
        print "  <W cv value callbacknum callbacksub> Legacy version. Callback values are arbitrary"
        print "  <B cv bit 0|1> Write bit to a cv a value of either 0 or 1."
        print "  <B cv bit value callbacknum callbacksub> legacy version. Callback values are arbitrary"
        print "  <R cv> Read CV BYTE (pending implementation)"
        print "  <R cv callbacknum callbacksub> Read CV BYTE (pending legacy)"
        print "  <V cv value> Verify/Read of cv with guessed value"
        print "  <V cv bit 0|1> Verify/Read bit of cv with guessed value"
        print "  <P ignored hex1 hex2 [hex3 [hex4 [hex5]]]> Writes a DCC packet to the PROG track"
        print " "
        print " 'Diagnostic Traces'"
        print "  <D ACK ON|OFF> Enables ACK diagnostics"
        print "  <D CABS> Shows Cab numbers and speed in reminder table"
        print "  <D CMD ON|OFF> Enables Command Parser diagnostics"
        print "  <D ETHERNET ON|OFF> Enables Ethernet diagnostics"
        print "  <D HAL SHOW>  List HAL Devices Status"
        print "  <D LCN ON|OFF> Enables LCN interface diagnostics"
        print "  <D RAM> Shows remaining RAM"
        print "  <D WIFI ON|OFF> Enables WiFi diagnostics"
        print "  <D WIT ON|OFF> Enables WiThrottle diagnostics"
        print " "
        print " 'Diagnostic Tuning'"
        print "  <D ACK LMIT mA> Overide 60mA default ACK processing mA pulse size"
        print "  <D ACK MIN uS>  Overide 4000uS default ACK processing minimum pulse width"
        print "  <D ACK MAX uS>  Overide 8500uS default ACK processing maximum pulse width" 
        print "  <D PROGBOOST>   Overide 250mA prog track trip limit while idle"
        print " "
        print " 'New I/O (HAL) Diagnostics'"
        print "  <D HAL SHOW> List HAL devices and allocated VPINs"
        print "  <D SERVO vpin value [profile]> Set servo position to value on pin vpin"
        print "  <D ANOUT vpin value [param2]> Write value to analogue pin vpin, supplying param2 to the driver"
        print "  <D ANIN vpin> Read and display pin vpin’s analogue value"
        print " "
        print " 'New EX-RAIL Commands' Used Thru the JMRI Send DCC++ Command pane"
        print "  <D EXRAIL ON|OFF>    Turns on/off diagnostic traces for EX-RAIL events"
        print "  </PAUSE>             Pauses all automation - all locos ESTOP"
        print "  </RESUME>            Resumes automation - all locos are restarted at speed when paused"
        print "  </START[loco_addr]route_id> Starts a new task to send loco onto Route, or activate a non-loco Animation or Sequence"
        print "  </>                  Displays EX-RAIL running thread information"
        print "  </KILL task_id>      Kill a currently running script task by id (use </> to list task ID's"
        print "  </KILL ALL>          Kill All currently running script tasks"
        print "  </RESERVE block_id>  Manually reserves a virtual track Block"
        print "  </FREE block_id>     Manually frees a virtual track Block"
        print "  </LATCH sensor_id>   Lock sensor ON, preventing external state "
        print "  </UNLATCH sensor_id> Unlock sensor, returning to current external state "
        print "  </RED signal_id>     Set the specified signal red "
        print "  </AMBER signal_id>   Set the specified signal amber "
        print "  </GREEN signal_id>   Set the specified signal green "
        print "  </ROUTES>            ** Under Development** Returns the Routes & Automations control list in WiThrottle format. JMRI integration only!"
        print " "
        print " 'Legacy DCC Accessories' Deprecated See DCC Accessory Decoder Turnouts"
        print "  <a linear_address 1|0> an Accessory Decoder linear 1-2044 address On or OFF"
        print "  <a addr subaddr 1|0>   an Accessory Decoder address 0-511 & sub 0-3 address On or OFF"
        print " "
        print " 'Legacy Turnouts' Deprecated See DCC Accessory Decoder Turnouts"
        print "  <T id address subaddress> Define DCC turnout"
        print "  <T id> Delete a turnout ID"
        print "  <T> List defined turnouts"
        print "  <T id 0|1> Throw (1) or Close(0) a defined turnout"
        print " "
        print " 'New DCC Accessory Decoder Turnout'"
        print "   From Version 3.1.7 and higher the Legacy commands are deprecated and have been replaced by"
        print "   Creating a new turnout ID which operates the DCC Accessory Decoder configured for the ADDRESS and SUBADDRESS"
        print "  <T ID DCC ADDRESS SUBADDRESS>"
        print "  <T 30 DCC 30 0>  Turnout 30, DCC Accessory Decoder configured for the ADDRESS 30, and SUBADDRESS 0"
        print "  <T id> Delete a turnout ID"
        print "  <T> List defined turnouts"
        print "  <T id 0|1> Throw (1) or Close(0) a defined turnout"
        print " "
        print " 'New Servo-based Turnout'"
        print "  Create a new turnout ID on a PCA9685 Servo Board with a Angle position range from 102 to 490, provides 180 degrees motion,"
        print "   and a PROFILE, as 0 (immediate), 1(fast=0.5 sec), 2(medium=1 sec), 3(slow=2 sec) or 4(bounce, for semaphore signals)"
        print "  Use Vpin 100-115 for servos attached to the first PCA9685 Servo Controller module, 116-131 for the second PCA9685 module,"
        print "   and Vpin 164-179 for pins on the first MCP23017 GPIO Extender module, and 180-195 for the second MCP23017 module."
        print "  <T ID SERVO PIN THROWNPOSITION CLOSEDPOSITION PROFILE>"
        print "  <T 1 SERVO 101 410 305 2> Turnout 1, vpin 101, Thrown 410 degree, Close 305 degree, speed 2 medium"
        print "  <T>  List defined turnouts"
        print "  <T id> Delete a turnout ID"
        print "  <T id 0|1> Throw (1 or T) or Close(0 or C) a defined turnout"
        print " "
        print " 'New VPIN-based Turnout'"
        print "   Create a new turnout ID which operates the output defined by PIN"
        print "  <T ID VPIN PIN>"
        print "  <T 30 VPIN 30 > Turnout 30 on Arduino pin D30"
        print " "
        print " 'New List all Turnouts <T> Command' The numeric ID (0-32767) are shared between Turnouts, Sensors & Outputs"
        print "  <H ID DCC ADDRESS SUBADDRESS THROWN> Status of a DCC Accessory Turnout"
        print "  <H ID SERVO PIN THROWNPOSITION CLOSEDPOSITION PROFILE THROWN> Status of a Servo Turnout"
        print "  <H ID VPIN PIN THROWN> `Status of a Vpin Turnout"
        print "  <H ID LCN THROWN> Status of a LCN Turnout"
        print " "
        print " 'Sensors'"
        print "  <Q> Lists Status of all sensors"
        print "  <S> Lists definition all defined sensors."
        print "  <S id pin 0|1>  Creates a new sensor ID, with specified PIN and PULLUP"
        print "  <S id>  Deletes definition of sensor ID"
        print " " 
        print " 'Outputs'"
        print "  <Z> Lists all defined output pins"
        print "  <Z id pin iflag> : Creates a new output ID, with specified PIN and IFLAG values."
        print "    IFLAG, bit 0: 0 = forward operation (ACTIVE=HIGH / INACTIVE=LOW)"
        print "                  1 = inverted operation (ACTIVE=LOW / INACTIVE=HIGH)"
        print "    IFLAG, bit 1: 0 = state of pin restored on power-up to either ACTIVE or INACTIVE"
        print "                      depending on state before power-down."
        print "                  1 = state of pin set on power-up, or when first created,"
        print "                      to either ACTIVE of INACTIVE depending on IFLAG, bit 2"
        print "    IFLAG, bit 2: 0 = state of pin set to INACTIVE upon power-up or when first created"
        print "                  1 = state of pin set to ACTIVE upon power-up or when first created"
        print "  <Z id 0|1> : Sets output ID to either INACTIVE or ACTIVE state"
        print "  <Z id>     : Deletes definition of output ID"
        print " "
        print " 'New Throttle Builder Transport Command'"
        print "  <JA> Command Station EXRAIL (n) Sequence List"
        print "  <JR> Command Station Roster List"
        print "  <JT> Command Station Turnout List"
        print ""
        print " // After Creating Turnouts, Sensors & Outputs Returns: <O> if successful and <X> if unsuccessful (e.g. out of memory)"
        print " "
        print " 'EEPROM Management'"
        print "  <E> Store definitions to EEPROM"
        print "  <e> Erase ALL (turnouts, sensors, and outputs) from EEPROM, **** Caution there's no Undo ****"
        print "  <D EEPROM > Diagnostic dump eeprom contents"
        print "  "
        print "  'WiFi Control Commands & Status' Works ONLY with Arduino IDE monitor, NOT JMRI Traffic monitor"
        print "  <+command> Sends AT+ commands to the WiFi board (ESP8266, ESP32, ESP01 etc.)"
        print "  <+X>       Force the CS into 'WiFi Connected' mode"
        print "  <+GMR>     Sends the 'AT+GMR' command prints version information from the WiFi device."
        print "  <+CIFSR>   Check WiFi in STA or AP mode and returns IP & MAC ID settings in the CS."
        print "  <+CIPSTA?> Check WiFi in STA or AP mode and returns IP, Gateway & Sub Netmask settings in the CS."
        print "  <+CISEND>  Check Wifi response"
        print "  <+CWJAP?>  Check WiFi in STA or AP mode and returns SSID Name & MAC ID settings in the CS."
        print "  <+CWLAP>   Check WiFi in STA or AP mode and returns available AP & STA Router Device."
        print "  <+CWHOSTNAME?> Check WiFi in Command Station and returns Host Name settings in the CS."
        print " "
        print " 'User Defined'"
        print "  <U ...> Is reserved for user commands (through user filter)"
        print " "
        print "*'End of DCC-EX Commands Group Summary''"
        print " DCC-EX Commands 4.1.0.py script by KCSmith 8-2022"
        print "***********************************************************************************************"
        print " "
        print " "

        return

Commands() .start()
